Sponsored Content
Full Discussion: Semaphore - lockfile/flock
Top Forums UNIX for Advanced & Expert Users Semaphore - lockfile/flock Post 302945541 by Don Cragun on Saturday 30th of May 2015 03:03:09 PM
Old 05-30-2015
Quote:
Originally Posted by MadeInGermany
Or use mkdir
Code:
#!/bin/sh
trap "rmdir lockdir" EXIT
if mkdir lockdir
then
  echo start process
fi

This is backwards. If you do it this way, you will destroy a lock set by another process if you don't get the lock... You only want to set that trap after you acquire the lock.
Code:
#!/bin/sh
if mkdir lockdir
then
  trap "rmdir lockdir" EXIT
  echo start process
fi

This User Gave Thanks to Don Cragun For This Post:
 

7 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

Retry every ten seconds while lockfile present

Hi, I have written below check lockfile script but need some tweaking on it. If there is a lockfile from present, I need the script to retry every 10 seconds to see if the lockfile is still there. After 120 seconds it should send an email. In my current version, if the script encounters... (6 Replies)
Discussion started by: Meert
6 Replies

2. Shell Programming and Scripting

"lockfile: command not found"

Just tried out the following code from "Using lockfiles in shell scripts": #!/bin/bash if ; then echo "File exists" else echo "File does not exists. Create file now." echo 1 > number.txt fi lockfile script.lock a=$(/usr/bin/tail -n 1 number.txt) if ; then... (1 Reply)
Discussion started by: courteous
1 Replies

3. UNIX for Advanced & Expert Users

Testing privileges -lock lockfile /var/lock/subsys/..- Permission denied

Hi all, I have to test some user priviliges. The goal is to be sure that an unauthorized user can't restart some modules (ssh, mysql etc...). I'm trying to automate it with a shell script but in same cases I got the syslog broadcast message. Is there any way to simply get a return code... (3 Replies)
Discussion started by: Dedalus
3 Replies

4. Shell Programming and Scripting

Bash Lockfile Command

Hi, I am new to this forum, could any one please help me to understand the LOCKFILE command with an example and what exactly it is used for and how it is used. Thanks Reshu289 (4 Replies)
Discussion started by: Reshu289
4 Replies

5. Shell Programming and Scripting

Help using Flock (file lock)

Hello, I have been working on using "flock"/file lock to prevent two instances of a bash script from being executed. Below is a simplified version of what I have to illustrate the flock part. It works as it is set up there below however the piece I am trying to figure out is how to get it to... (2 Replies)
Discussion started by: infrared013
2 Replies

6. Shell Programming and Scripting

Use of flock command for whole script

I'm changing my mindset from a few big processes moving data from a few sources under an external, dependency-based scheduler to multiple processes moving data from many sources run by each client cron and possibly interfering with each other. It has the benefits of more granular code but I'm... (11 Replies)
Discussion started by: rbatte1
11 Replies

7. Shell Programming and Scripting

Flock preventing function to work

Hi i have a script that check pings and i use flock to so the script wont run multipul times : its not the whole script but this is the idea : ( flock -x -w 3 200 || exit 1 /usr/sbin/fping -c$count -i$interval -a $hosts > $FILE1 2>&1 ) 200>/var/lock/.myscript.exclusivelock now i... (4 Replies)
Discussion started by: batchenr
4 Replies
SHLOCK(1)						      General Commands Manual							 SHLOCK(1)

NAME
       shlock - create lock files for use in shell scripts

SYNOPSIS
       shlock -p pid -f name [ -b ] [ -u ] [ -c ]

DESCRIPTION
       Shlock  tries  to  create  a  lock  file named name and write the process ID pid into it.  If the file already exists, shlock will read the
       process ID from the file and test to see if the process is currently running.  If the process exists, then the file will not be created.

       Shlock exits with a zero status if it was able to create the lock file, or non-zero if the file refers to currently-active process.

OPTIONS
       -b     Process IDs are normally read and written in ASCII.  If the ``-b'' flag is used, then they will be written as  a	binary	int.   For
	      compatibility with other systems, the ``-u'' flag is accepted as a synonym for ``-b'' since binary locks are used by many UUCP pack-
	      ages.

       -c     If the ``-c'' flag is used, then shlock will not create a lock file, but will instead use the file to see if the	lock  is  held	by
	      another  program.   If  the  lock  is  valid, the program will exit with a non-zero status; if the lock is not valid (i.e., invoking
	      shlock without the flag would have succeeded), then the program will exit with a zero status.

EXAMPLES
       The following example shows how shlock would be used within a shell script:
	      LOCK=/var/run/innd/LOCK.send
	      trap 'rm -f ${LOCK} ; exit 1' 1 2 3 15
	      if shlock -p $$ -f ${LOCK} ; then
		  # Do appropriate work
	      else
		  echo Locked by `cat ${LOCK}`
	      fi

HISTORY
       Written by Rich $alz <rsalz@uunet.uu.net> after a description of HDB UUCP locking given by Peter Honeyman.  This  is  revision  1.9,  dated
       1996/10/29.

																	 SHLOCK(1)
All times are GMT -4. The time now is 11:11 PM.
Unix & Linux Forums Content Copyright 1993-2022. All Rights Reserved.
Privacy Policy